/*!
 * vue-transcript-editor v0.4.1-next.0 
 * (c) 2021 Konstantint Travin
 * Released under the MIT License.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-plyr'), require('moment')) :
  typeof define === 'function' && define.amd ? define(['exports', 'vue-plyr', 'moment'], factory) :
  (global = global || self, factory(global.VueTranscriptEditor = {}, global.VuePlyr, global.moment));
}(this, (function (exports, VuePlyr, moment) { 'use strict';

  VuePlyr = VuePlyr && Object.prototype.hasOwnProperty.call(VuePlyr, 'default') ? VuePlyr['default'] : VuePlyr;
  moment = moment && Object.prototype.hasOwnProperty.call(moment, 'default') ? moment['default'] : moment;

  //
  //
  //
  //
  //
  //
  //
  //
  var script = {
    name: "EmotionSwitcher",
    props: {
      isHide: {
        required: true,
        type: Boolean
      }
    },
    data: function data() {
      return {
        switcherIsHide: this.isHide
      };
    },
    computed: {
      condition: function condition() {
        return {
          show: "Включить эмоции",
          hide: "Скрыть эмоции"
        };
      },
      content: function content() {
        return this.switcherIsHide ? this.condition.show : this.condition.hide;
      }
    },
    methods: {
      toggle: function toggle() {
        this.switcherIsHide = !this.switcherIsHide;
        this.$emit("emotionToggle");
      }
    }
  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function (context) {
        style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  /* script */
  const __vue_script__ = script;
  /* template */
  var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('button',{staticClass:"btn btn-primary",on:{"click":_vm.toggle}},[_vm._v("\n    "+_vm._s(_vm.content)+"\n  ")])])};
  var __vue_staticRenderFns__ = [];

    /* style */
    const __vue_inject_styles__ = undefined;
    /* scoped */
    const __vue_scope_id__ = "data-v-4ec2404c";
    /* module identifier */
    const __vue_module_identifier__ = undefined;
    /* functional template */
    const __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__ = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      false,
      undefined,
      undefined,
      undefined
    );

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  var script$1 = {
    name: "EmotionLegend",
    props: {
      emotionColors: {
        type: Object,
        required: true
      }
    },
    computed: {
      legendItems: function legendItems() {
        var entries = Object.entries(this.emotionColors);
        return entries.map(function (_ref, index) {
          var _ref2 = _slicedToArray(_ref, 2),
              emotion = _ref2[0],
              color = _ref2[1];

          return {
            index: index,
            color: color,
            label: emotion
          };
        });
      },
      legendExist: function legendExist() {
        return !!this.legendItems.length;
      }
    }
  };

  /* script */
  const __vue_script__$1 = script$1;
  /* template */
  var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"legend"},[_c('p',{staticClass:"legend--title"}),_vm._v(" "),_c('div',{staticClass:"legend--items"},_vm._l((_vm.legendItems),function(item){return _c('div',{key:item.index,staticClass:"legend--item"},[_c('div',{staticClass:"square",style:({ background: item.color })}),_vm._v(" "),_c('div',{staticClass:"legend--item--label"},[_vm._v(_vm._s(item.label))])])}),0)])};
  var __vue_staticRenderFns__$1 = [];

    /* style */
    const __vue_inject_styles__$1 = undefined;
    /* scoped */
    const __vue_scope_id__$1 = "data-v-541ae22a";
    /* module identifier */
    const __vue_module_identifier__$1 = undefined;
    /* functional template */
    const __vue_is_functional_template__$1 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$1 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
      __vue_inject_styles__$1,
      __vue_script__$1,
      __vue_scope_id__$1,
      __vue_is_functional_template__$1,
      __vue_module_identifier__$1,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$2 = {
    name: "TranscriptHeader",
    components: {
      EmotionSwitcher: __vue_component__,
      EmotionLegend: __vue_component__$1
    },
    props: {
      width: {
        type: Number,
        required: true
      },
      marginTop: {
        type: Number,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        offset: this.marginTop + 80
      };
    },
    computed: {
      legendStyles: function legendStyles() {
        return {
          opacity: this.emotionHidden ? 0 : 1
        };
      },
      affixStyles: function affixStyles() {
        return {
          display: "flex",
          flexDirection: "row",
          flexWrap: "nowrap",
          justifyContent: "space-between",
          alignItems: "center",
          alignContent: "stretch",
          zIndex: 1,
          width: "".concat(this.width, "px"),
          background: "#ffffff"
        };
      }
    }
  };

  /* script */
  const __vue_script__$2 = script$2;
  /* template */
  var __vue_render__$2 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('affix',{style:(_vm.affixStyles),attrs:{"offset":{ top: _vm.offset, bottom: _vm.offset },"relative-element-selector":"#transcript"}},[_c('emotion-switcher',{attrs:{"is-hide":_vm.emotionHidden},on:{"emotionToggle":function($event){return _vm.$emit('emotionToggle')}}}),_vm._v(" "),_c('emotion-legend',{style:(_vm.legendStyles),attrs:{"emotion-colors":_vm.emotionColors}})],1)};
  var __vue_staticRenderFns__$2 = [];

    /* style */
    const __vue_inject_styles__$2 = undefined;
    /* scoped */
    const __vue_scope_id__$2 = "data-v-2a26b7e6";
    /* module identifier */
    const __vue_module_identifier__$2 = undefined;
    /* functional template */
    const __vue_is_functional_template__$2 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$2 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
      __vue_inject_styles__$2,
      __vue_script__$2,
      __vue_scope_id__$2,
      __vue_is_functional_template__$2,
      __vue_module_identifier__$2,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$3 = {
    name: "Player",
    components: {
      VuePlyr: VuePlyr
    },
    props: {
      width: {
        required: true,
        type: Number
      },
      sourceFile: {
        required: true,
        type: String
      }
    },
    data: function data() {
      return {
        loading: true
      };
    },
    computed: {
      playerStyles: function playerStyles() {
        return {
          width: "".concat(this.width, "px")
        };
      }
    },
    mounted: function mounted() {
      var _this = this;

      this.$refs.audioElement.addEventListener("error", function () {
        console.log("ошибка загрузки файла");
      }, false);
      this.$refs.audioElement.addEventListener("loadeddata", function () {
        if (isNaN(_this.$refs.audioElement.duration)) {
          console.log("audio source is invalid");
          return;
        }

        _this.loading = false;
      }, false);
      this.$refs.audioElement.src = this.sourceFile;
    }
  };

  /* script */
  const __vue_script__$3 = script$3;
  /* template */
  var __vue_render__$3 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{directives:[{name:"show",rawName:"v-show",value:(!_vm.loading),expression:"!loading"}],staticClass:"player-wrapper",style:(_vm.playerStyles)},[_c('vue-plyr',[_c('audio',{ref:"audioElement"},[_c('source')])])],1)};
  var __vue_staticRenderFns__$3 = [];

    /* style */
    const __vue_inject_styles__$3 = undefined;
    /* scoped */
    const __vue_scope_id__$3 = "data-v-1986f832";
    /* module identifier */
    const __vue_module_identifier__$3 = undefined;
    /* functional template */
    const __vue_is_functional_template__$3 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$3 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
      __vue_inject_styles__$3,
      __vue_script__$3,
      __vue_scope_id__$3,
      __vue_is_functional_template__$3,
      __vue_module_identifier__$3,
      false,
      undefined,
      undefined,
      undefined
    );

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var runtime_1 = createCommonjsModule(function (module) {
    /**
     * Copyright (c) 2014-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    var runtime = function (exports) {

      var Op = Object.prototype;
      var hasOwn = Op.hasOwnProperty;
      var undefined$1; // More compressible than void 0.

      var $Symbol = typeof Symbol === "function" ? Symbol : {};
      var iteratorSymbol = $Symbol.iterator || "@@iterator";
      var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
      var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

      function define(obj, key, value) {
        Object.defineProperty(obj, key, {
          value: value,
          enumerable: true,
          configurable: true,
          writable: true
        });
        return obj[key];
      }

      try {
        // IE 8 has a broken Object.defineProperty that only works on DOM objects.
        define({}, "");
      } catch (err) {
        define = function define(obj, key, value) {
          return obj[key] = value;
        };
      }

      function wrap(innerFn, outerFn, self, tryLocsList) {
        // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
        var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
        var generator = Object.create(protoGenerator.prototype);
        var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
        // .throw, and .return methods.

        generator._invoke = makeInvokeMethod(innerFn, self, context);
        return generator;
      }

      exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
      // record like context.tryEntries[i].completion. This interface could
      // have been (and was previously) designed to take a closure to be
      // invoked without arguments, but in all the cases we care about we
      // already have an existing method we want to call, so there's no need
      // to create a new function object. We can even get away with assuming
      // the method takes exactly one argument, since that happens to be true
      // in every case, so we don't have to touch the arguments object. The
      // only additional allocation required is the completion record, which
      // has a stable shape and so hopefully should be cheap to allocate.

      function tryCatch(fn, obj, arg) {
        try {
          return {
            type: "normal",
            arg: fn.call(obj, arg)
          };
        } catch (err) {
          return {
            type: "throw",
            arg: err
          };
        }
      }

      var GenStateSuspendedStart = "suspendedStart";
      var GenStateSuspendedYield = "suspendedYield";
      var GenStateExecuting = "executing";
      var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
      // breaking out of the dispatch switch statement.

      var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
      // .constructor.prototype properties for functions that return Generator
      // objects. For full spec compliance, you may wish to configure your
      // minifier not to mangle the names of these two functions.

      function Generator() {}

      function GeneratorFunction() {}

      function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
      // don't natively support it.


      var IteratorPrototype = {};
      define(IteratorPrototype, iteratorSymbol, function () {
        return this;
      });
      var getProto = Object.getPrototypeOf;
      var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

      if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
        // This environment has a native %IteratorPrototype%; use it instead
        // of the polyfill.
        IteratorPrototype = NativeIteratorPrototype;
      }

      var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
      GeneratorFunction.prototype = GeneratorFunctionPrototype;
      define(Gp, "constructor", GeneratorFunctionPrototype);
      define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
      GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"); // Helper for defining the .next, .throw, and .return methods of the
      // Iterator interface in terms of a single ._invoke method.

      function defineIteratorMethods(prototype) {
        ["next", "throw", "return"].forEach(function (method) {
          define(prototype, method, function (arg) {
            return this._invoke(method, arg);
          });
        });
      }

      exports.isGeneratorFunction = function (genFun) {
        var ctor = typeof genFun === "function" && genFun.constructor;
        return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
      };

      exports.mark = function (genFun) {
        if (Object.setPrototypeOf) {
          Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
        } else {
          genFun.__proto__ = GeneratorFunctionPrototype;
          define(genFun, toStringTagSymbol, "GeneratorFunction");
        }

        genFun.prototype = Object.create(Gp);
        return genFun;
      }; // Within the body of any async function, `await x` is transformed to
      // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
      // `hasOwn.call(value, "__await")` to determine if the yielded value is
      // meant to be awaited.


      exports.awrap = function (arg) {
        return {
          __await: arg
        };
      };

      function AsyncIterator(generator, PromiseImpl) {
        function invoke(method, arg, resolve, reject) {
          var record = tryCatch(generator[method], generator, arg);

          if (record.type === "throw") {
            reject(record.arg);
          } else {
            var result = record.arg;
            var value = result.value;

            if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
              return PromiseImpl.resolve(value.__await).then(function (value) {
                invoke("next", value, resolve, reject);
              }, function (err) {
                invoke("throw", err, resolve, reject);
              });
            }

            return PromiseImpl.resolve(value).then(function (unwrapped) {
              // When a yielded Promise is resolved, its final value becomes
              // the .value of the Promise<{value,done}> result for the
              // current iteration.
              result.value = unwrapped;
              resolve(result);
            }, function (error) {
              // If a rejected Promise was yielded, throw the rejection back
              // into the async generator function so it can be handled there.
              return invoke("throw", error, resolve, reject);
            });
          }
        }

        var previousPromise;

        function enqueue(method, arg) {
          function callInvokeWithMethodAndArg() {
            return new PromiseImpl(function (resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }

          return previousPromise = // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        } // Define the unified helper method that is used to implement .next,
        // .throw, and .return (see defineIteratorMethods).


        this._invoke = enqueue;
      }

      defineIteratorMethods(AsyncIterator.prototype);
      define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
        return this;
      });
      exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
      // AsyncIterator objects; they just return a Promise for the value of
      // the final result produced by the iterator.

      exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
        if (PromiseImpl === void 0) PromiseImpl = Promise;
        var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
        return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function (result) {
          return result.done ? result.value : iter.next();
        });
      };

      function makeInvokeMethod(innerFn, self, context) {
        var state = GenStateSuspendedStart;
        return function invoke(method, arg) {
          if (state === GenStateExecuting) {
            throw new Error("Generator is already running");
          }

          if (state === GenStateCompleted) {
            if (method === "throw") {
              throw arg;
            } // Be forgiving, per 25.3.3.3.3 of the spec:
            // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


            return doneResult();
          }

          context.method = method;
          context.arg = arg;

          while (true) {
            var delegate = context.delegate;

            if (delegate) {
              var delegateResult = maybeInvokeDelegate(delegate, context);

              if (delegateResult) {
                if (delegateResult === ContinueSentinel) continue;
                return delegateResult;
              }
            }

            if (context.method === "next") {
              // Setting context._sent for legacy support of Babel's
              // function.sent implementation.
              context.sent = context._sent = context.arg;
            } else if (context.method === "throw") {
              if (state === GenStateSuspendedStart) {
                state = GenStateCompleted;
                throw context.arg;
              }

              context.dispatchException(context.arg);
            } else if (context.method === "return") {
              context.abrupt("return", context.arg);
            }

            state = GenStateExecuting;
            var record = tryCatch(innerFn, self, context);

            if (record.type === "normal") {
              // If an exception is thrown from innerFn, we leave state ===
              // GenStateExecuting and loop back for another invocation.
              state = context.done ? GenStateCompleted : GenStateSuspendedYield;

              if (record.arg === ContinueSentinel) {
                continue;
              }

              return {
                value: record.arg,
                done: context.done
              };
            } else if (record.type === "throw") {
              state = GenStateCompleted; // Dispatch the exception by looping back around to the
              // context.dispatchException(context.arg) call above.

              context.method = "throw";
              context.arg = record.arg;
            }
          }
        };
      } // Call delegate.iterator[context.method](context.arg) and handle the
      // result, either by returning a { value, done } result from the
      // delegate iterator, or by modifying context.method and context.arg,
      // setting context.delegate to null, and returning the ContinueSentinel.


      function maybeInvokeDelegate(delegate, context) {
        var method = delegate.iterator[context.method];

        if (method === undefined$1) {
          // A .throw or .return when the delegate iterator has no .throw
          // method always terminates the yield* loop.
          context.delegate = null;

          if (context.method === "throw") {
            // Note: ["return"] must be used for ES3 parsing compatibility.
            if (delegate.iterator["return"]) {
              // If the delegate iterator has a return method, give it a
              // chance to clean up.
              context.method = "return";
              context.arg = undefined$1;
              maybeInvokeDelegate(delegate, context);

              if (context.method === "throw") {
                // If maybeInvokeDelegate(context) changed context.method from
                // "return" to "throw", let that override the TypeError below.
                return ContinueSentinel;
              }
            }

            context.method = "throw";
            context.arg = new TypeError("The iterator does not provide a 'throw' method");
          }

          return ContinueSentinel;
        }

        var record = tryCatch(method, delegate.iterator, context.arg);

        if (record.type === "throw") {
          context.method = "throw";
          context.arg = record.arg;
          context.delegate = null;
          return ContinueSentinel;
        }

        var info = record.arg;

        if (!info) {
          context.method = "throw";
          context.arg = new TypeError("iterator result is not an object");
          context.delegate = null;
          return ContinueSentinel;
        }

        if (info.done) {
          // Assign the result of the finished delegate to the temporary
          // variable specified by delegate.resultName (see delegateYield).
          context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

          context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
          // exception, let the outer generator proceed normally. If
          // context.method was "next", forget context.arg since it has been
          // "consumed" by the delegate iterator. If context.method was
          // "return", allow the original .return call to continue in the
          // outer generator.

          if (context.method !== "return") {
            context.method = "next";
            context.arg = undefined$1;
          }
        } else {
          // Re-yield the result returned by the delegate method.
          return info;
        } // The delegate iterator is finished, so forget it and continue with
        // the outer generator.


        context.delegate = null;
        return ContinueSentinel;
      } // Define Generator.prototype.{next,throw,return} in terms of the
      // unified ._invoke helper method.


      defineIteratorMethods(Gp);
      define(Gp, toStringTagSymbol, "Generator"); // A Generator should always return itself as the iterator object when the
      // @@iterator function is called on it. Some browsers' implementations of the
      // iterator prototype chain incorrectly implement this, causing the Generator
      // object to not be returned from this call. This ensures that doesn't happen.
      // See https://github.com/facebook/regenerator/issues/274 for more details.

      define(Gp, iteratorSymbol, function () {
        return this;
      });
      define(Gp, "toString", function () {
        return "[object Generator]";
      });

      function pushTryEntry(locs) {
        var entry = {
          tryLoc: locs[0]
        };

        if (1 in locs) {
          entry.catchLoc = locs[1];
        }

        if (2 in locs) {
          entry.finallyLoc = locs[2];
          entry.afterLoc = locs[3];
        }

        this.tryEntries.push(entry);
      }

      function resetTryEntry(entry) {
        var record = entry.completion || {};
        record.type = "normal";
        delete record.arg;
        entry.completion = record;
      }

      function Context(tryLocsList) {
        // The root entry object (effectively a try statement without a catch
        // or a finally block) gives us a place to store values thrown from
        // locations where there is no enclosing try statement.
        this.tryEntries = [{
          tryLoc: "root"
        }];
        tryLocsList.forEach(pushTryEntry, this);
        this.reset(true);
      }

      exports.keys = function (object) {
        var keys = [];

        for (var key in object) {
          keys.push(key);
        }

        keys.reverse(); // Rather than returning an object with a next method, we keep
        // things simple and return the next function itself.

        return function next() {
          while (keys.length) {
            var key = keys.pop();

            if (key in object) {
              next.value = key;
              next.done = false;
              return next;
            }
          } // To avoid creating an additional object, we just hang the .value
          // and .done properties off the next function object itself. This
          // also ensures that the minifier will not anonymize the function.


          next.done = true;
          return next;
        };
      };

      function values(iterable) {
        if (iterable) {
          var iteratorMethod = iterable[iteratorSymbol];

          if (iteratorMethod) {
            return iteratorMethod.call(iterable);
          }

          if (typeof iterable.next === "function") {
            return iterable;
          }

          if (!isNaN(iterable.length)) {
            var i = -1,
                next = function next() {
              while (++i < iterable.length) {
                if (hasOwn.call(iterable, i)) {
                  next.value = iterable[i];
                  next.done = false;
                  return next;
                }
              }

              next.value = undefined$1;
              next.done = true;
              return next;
            };

            return next.next = next;
          }
        } // Return an iterator with no values.


        return {
          next: doneResult
        };
      }

      exports.values = values;

      function doneResult() {
        return {
          value: undefined$1,
          done: true
        };
      }

      Context.prototype = {
        constructor: Context,
        reset: function reset(skipTempReset) {
          this.prev = 0;
          this.next = 0; // Resetting context._sent for legacy support of Babel's
          // function.sent implementation.

          this.sent = this._sent = undefined$1;
          this.done = false;
          this.delegate = null;
          this.method = "next";
          this.arg = undefined$1;
          this.tryEntries.forEach(resetTryEntry);

          if (!skipTempReset) {
            for (var name in this) {
              // Not sure about the optimal order of these conditions:
              if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
                this[name] = undefined$1;
              }
            }
          }
        },
        stop: function stop() {
          this.done = true;
          var rootEntry = this.tryEntries[0];
          var rootRecord = rootEntry.completion;

          if (rootRecord.type === "throw") {
            throw rootRecord.arg;
          }

          return this.rval;
        },
        dispatchException: function dispatchException(exception) {
          if (this.done) {
            throw exception;
          }

          var context = this;

          function handle(loc, caught) {
            record.type = "throw";
            record.arg = exception;
            context.next = loc;

            if (caught) {
              // If the dispatched exception was caught by a catch block,
              // then let that catch block handle the exception normally.
              context.method = "next";
              context.arg = undefined$1;
            }

            return !!caught;
          }

          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];
            var record = entry.completion;

            if (entry.tryLoc === "root") {
              // Exception thrown outside of any try block that could handle
              // it, so set the completion value of the entire function to
              // throw the exception.
              return handle("end");
            }

            if (entry.tryLoc <= this.prev) {
              var hasCatch = hasOwn.call(entry, "catchLoc");
              var hasFinally = hasOwn.call(entry, "finallyLoc");

              if (hasCatch && hasFinally) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                } else if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else if (hasCatch) {
                if (this.prev < entry.catchLoc) {
                  return handle(entry.catchLoc, true);
                }
              } else if (hasFinally) {
                if (this.prev < entry.finallyLoc) {
                  return handle(entry.finallyLoc);
                }
              } else {
                throw new Error("try statement without catch or finally");
              }
            }
          }
        },
        abrupt: function abrupt(type, arg) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
              var finallyEntry = entry;
              break;
            }
          }

          if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
            // Ignore the finally entry if control is not jumping to a
            // location outside the try/catch block.
            finallyEntry = null;
          }

          var record = finallyEntry ? finallyEntry.completion : {};
          record.type = type;
          record.arg = arg;

          if (finallyEntry) {
            this.method = "next";
            this.next = finallyEntry.finallyLoc;
            return ContinueSentinel;
          }

          return this.complete(record);
        },
        complete: function complete(record, afterLoc) {
          if (record.type === "throw") {
            throw record.arg;
          }

          if (record.type === "break" || record.type === "continue") {
            this.next = record.arg;
          } else if (record.type === "return") {
            this.rval = this.arg = record.arg;
            this.method = "return";
            this.next = "end";
          } else if (record.type === "normal" && afterLoc) {
            this.next = afterLoc;
          }

          return ContinueSentinel;
        },
        finish: function finish(finallyLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.finallyLoc === finallyLoc) {
              this.complete(entry.completion, entry.afterLoc);
              resetTryEntry(entry);
              return ContinueSentinel;
            }
          }
        },
        "catch": function _catch(tryLoc) {
          for (var i = this.tryEntries.length - 1; i >= 0; --i) {
            var entry = this.tryEntries[i];

            if (entry.tryLoc === tryLoc) {
              var record = entry.completion;

              if (record.type === "throw") {
                var thrown = record.arg;
                resetTryEntry(entry);
              }

              return thrown;
            }
          } // The context.catch method must only be called with a location
          // argument that corresponds to a known catch block.


          throw new Error("illegal catch attempt");
        },
        delegateYield: function delegateYield(iterable, resultName, nextLoc) {
          this.delegate = {
            iterator: values(iterable),
            resultName: resultName,
            nextLoc: nextLoc
          };

          if (this.method === "next") {
            // Deliberately forget the last sent value so that we don't
            // accidentally pass it on to the delegate.
            this.arg = undefined$1;
          }

          return ContinueSentinel;
        }
      }; // Regardless of whether this script is executing as a CommonJS module
      // or not, return the runtime object so that we can declare the variable
      // regeneratorRuntime in the outer scope, which allows this module to be
      // injected easily by `bin/regenerator --include-runtime script.js`.

      return exports;
    }( // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
     module.exports );

    try {
      regeneratorRuntime = runtime;
    } catch (accidentalStrictMode) {
      // This module should not be running in strict mode, so the above
      // assignment should always work unless something is misconfigured. Just
      // in case runtime.js accidentally runs in strict mode, in modern engines
      // we can explicitly access globalThis. In older engines we can escape
      // strict mode using a global Function call. This could conceivably fail
      // if a Content Security Policy forbids using Function, but in that case
      // the proper solution is to fix the accidental strict mode problem. If
      // you've misconfigured your bundler to force strict mode and applied a
      // CSP to forbid Function, and you're not willing to fix either of those
      // problems, please detail your unique predicament in a GitHub issue.
      if ((typeof globalThis === "undefined" ? "undefined" : _typeof(globalThis)) === "object") {
        globalThis.regeneratorRuntime = runtime;
      } else {
        Function("r", "regeneratorRuntime = r")(runtime);
      }
    }
  });

  var regenerator = runtime_1;

  var emotionColors = {
    angry: '#fc2863',
    happy: '#ffd318',
    sad: '#272932',
    surprise: '#ff842c',
    neutral: '#e7ecef',
    default: 'transparent'
  };
  function getColor(emotion) {
    var emotionColors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : emotionColors;
    return Object.prototype.hasOwnProperty.call(emotionColors, emotion) && emotionColors[emotion] || emotionColors.default;
  }

  var script$4 = {
    name: "SpeechWord",
    props: {
      value: {
        type: String,
        required: true
      },
      conf: {
        type: Number,
        required: true
      },
      start: {
        type: Number,
        required: true
      },
      end: {
        type: Number,
        required: true
      },
      emotion: {
        type: String,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      }
    },
    watch: {
      value: function value() {
        if (this.value !== this.$refs.contenteditable.innerText) {
          //Will reset cursor position, so only do this when the external component
          //completely changes the value (so not something caused by emitting the input event
          //and the reactivity framework)
          //TODO: Get smarter about this?
          this.$refs.contenteditable.textContent = this.value;
        }
      }
    },
    mounted: function mounted() {
      this.$refs.contenteditable.textContent = this.value;
    },
    methods: {
      wordStyle: function wordStyle(emotion) {
        return !this.emotionHidden ? {
          borderBottom: "2px solid ".concat(getColor(emotion, this.emotionColors))
        } : {};
      },
      onInput: function () {
        var _onInput = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
          var text;
          return regenerator.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  text = this.$refs.contenteditable.textContent;
                  this.$emit("input", text);

                case 2:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function onInput() {
          return _onInput.apply(this, arguments);
        }

        return onInput;
      }(),
      getCaretPosition: function getCaretPosition() {
        var caretOffset = 0;

        if (Object.hasOwnProperty.call(window, "getSelection")) {
          var range = window.getSelection().getRangeAt(0);
          var preCaretRange = range.cloneRange();
          preCaretRange.selectNodeContents(preCaretRange.startContainer);
          preCaretRange.setEnd(range.endContainer, range.endOffset);
          caretOffset = preCaretRange.toString().length;
          return [preCaretRange.startContainer, caretOffset];
        }

        return [null, 0];
      },
      setCaretPosition: function setCaretPosition(element, position) {
        var range = document.createRange();
        range.setStart(element, position);
        range.setEnd(element, position);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
      },
      onKeyDown: function onKeyDown(e) {
        var _this$getCaretPositio = this.getCaretPosition(),
            _this$getCaretPositio2 = _slicedToArray(_this$getCaretPositio, 2),
            targetElement = _this$getCaretPositio2[0],
            savedPosition = _this$getCaretPositio2[1];

        if (e.ctrlKey && e.which === 39 || e.which === 39 && savedPosition >= targetElement.textContent.length) {
          var element = e.target.nextSibling;

          if (element) {
            element.focus();
            this.setCaretPosition(element, 0);
          }
        } else if (e.ctrlKey && e.which === 37 || e.which === 37 && savedPosition === 0) {
          var _element = e.target.previousSibling;

          if (_element) {
            _element.focus();

            this.setCaretPosition(_element, 1);
          }
        }

        this.$emit("keydown", e);
      }
    }
  };

  /* script */
  const __vue_script__$4 = script$4;
  /* template */
  var __vue_render__$4 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('span',{ref:"contenteditable",staticClass:"speech-word",style:(_vm.wordStyle(_vm.emotion)),attrs:{"contenteditable":"","data-conf":_vm.conf,"data-end":_vm.end,"data-start":_vm.start},on:{"input":_vm.onInput,"paste":function($event){$event.preventDefault();},"keydown":_vm.onKeyDown,"keyup":function($event){return _vm.$emit('keyup', $event)},"keypress":[function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }$event.preventDefault();},function($event){return _vm.$emit('keypress', $event)}]}})};
  var __vue_staticRenderFns__$4 = [];

    /* style */
    const __vue_inject_styles__$4 = undefined;
    /* scoped */
    const __vue_scope_id__$4 = "data-v-db837eb4";
    /* module identifier */
    const __vue_module_identifier__$4 = undefined;
    /* functional template */
    const __vue_is_functional_template__$4 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$4 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
      __vue_inject_styles__$4,
      __vue_script__$4,
      __vue_scope_id__$4,
      __vue_is_functional_template__$4,
      __vue_module_identifier__$4,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$5 = {
    name: "SpeechTimestamp",
    props: {
      speakerId: {
        type: [String, Number],
        required: true
      },
      timestamp: {
        type: Number,
        required: true
      }
    },
    methods: {
      getTimestamp: function getTimestamp(data) {
        var format = data > 3600 ? "HH:mm:ss" : "mm:ss";
        return moment.utc(data * 1000).format(format);
      },
      displaySpeakerName: function displaySpeakerName(speaker_id) {
        return +speaker_id ? "Speaker ".concat(speaker_id) : speaker_id;
      }
    }
  };

  /* script */
  const __vue_script__$5 = script$5;
  /* template */
  var __vue_render__$5 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('p',{staticClass:"speech-timestamp"},[_c('span',{staticClass:"speech-timestamp-content"},[_c('span',{staticClass:"speaker-photo"}),_vm._v(" "),_c('strong',{staticClass:"speaker-name"},[_vm._v("\n      "+_vm._s(_vm.displaySpeakerName(_vm.speakerId))+"\n    ")]),_vm._v("\n    "+_vm._s(_vm.getTimestamp(_vm.timestamp))+"\n  ")])])};
  var __vue_staticRenderFns__$5 = [];

    /* style */
    const __vue_inject_styles__$5 = undefined;
    /* scoped */
    const __vue_scope_id__$5 = "data-v-00ea0c5f";
    /* module identifier */
    const __vue_module_identifier__$5 = undefined;
    /* functional template */
    const __vue_is_functional_template__$5 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$5 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
      __vue_inject_styles__$5,
      __vue_script__$5,
      __vue_scope_id__$5,
      __vue_is_functional_template__$5,
      __vue_module_identifier__$5,
      false,
      undefined,
      undefined,
      undefined
    );

  var script$6 = {
    name: "Speech",
    components: {
      SpeechWord: __vue_component__$4,
      SpeechTimestamp: __vue_component__$5
    },
    props: {
      speech: {
        type: Object,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      },
      isEditable: {
        type: Boolean,
        required: true
      }
    },
    data: function data() {
      return {
        speechProp: _objectSpread2({}, this.speech)
      };
    },
    watch: {
      speechProp: {
        handler: function handler(newSpeech) {
          this.$emit("handleSpeechEdit", {
            speech: this.speechProp,
            updatedSpeech: newSpeech.text
          });
        },
        deep: true
      }
    },
    methods: {
      isInterviewer: function isInterviewer(speaker_id) {
        var speaker = this.speakerList.find(function (item) {
          return item.speaker_id === speaker_id;
        });
        return speaker && speaker.is_interviewer ? "interviewer-speaker" : "";
      }
    }
  };

  /* script */
  const __vue_script__$6 = script$6;
  /* template */
  var __vue_render__$6 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"speech",class:_vm.isInterviewer(_vm.speechProp.speaker_id),on:{"click":function($event){return _vm.$emit('handleSpeechSelect', _vm.speechProp)}}},[_c('speech-timestamp',{attrs:{"speaker-id":_vm.speechProp.speaker_id,"timestamp":_vm.speechProp.timestamp}}),_vm._v(" "),_c('p',{staticClass:"speech-content",attrs:{"id":"editor"}},_vm._l((_vm.speechProp.text),function(word,key){return _c('speech-word',{key:key,attrs:{"conf":word.conf,"start":word.start,"end":word.end,"emotion":word.emotion,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.emotionHidden},model:{value:(word.word),callback:function ($$v) {_vm.$set(word, "word", $$v);},expression:"word.word"}})}),1)],1)};
  var __vue_staticRenderFns__$6 = [];

    /* style */
    const __vue_inject_styles__$6 = undefined;
    /* scoped */
    const __vue_scope_id__$6 = "data-v-14e0e407";
    /* module identifier */
    const __vue_module_identifier__$6 = undefined;
    /* functional template */
    const __vue_is_functional_template__$6 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$6 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
      __vue_inject_styles__$6,
      __vue_script__$6,
      __vue_scope_id__$6,
      __vue_is_functional_template__$6,
      __vue_module_identifier__$6,
      false,
      undefined,
      undefined,
      undefined
    );

  var script$7 = {
    name: "Transcript",
    components: {
      Speech: __vue_component__$6
    },
    props: {
      speeches: {
        type: Array,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: true
      },
      emotionHidden: {
        type: Boolean,
        required: false,
        default: false
      },
      isEditable: {
        type: Boolean,
        required: true
      }
    },
    data: function data() {
      return {
        player: null,
        transcript: null,
        activeSpeech: null,
        isDirty: false,
        words: [],
        paras: []
      };
    },
    mounted: function mounted() {
      this.initPlayer();
      this.initTranscript();
      this.initSpeeches();
    },
    methods: {
      initPlayer: function initPlayer() {
        var _this = this;

        this.$parent.$children.forEach(function (child) {
          if (Object.hasOwnProperty.call(child.$refs, "audioElement")) {
            _this.player = child.$refs.audioElement;

            _this.player.addEventListener("timeupdate", _this.checkPlayHead, false);
          }
        });
      },
      initTranscript: function initTranscript() {
        if (this.$refs.transcript) {
          this.transcript = this.$refs.transcript;
          this.transcript.addEventListener("click", this.setPlayHead, false);
        }
      },
      initSpeeches: function initSpeeches() {
        this.words = _toConsumableArray(this.transcript.getElementsByClassName("speech-word"));
        this.paras = _toConsumableArray(this.transcript.getElementsByClassName("speech"));
      },
      clearActiveElements: function clearActiveElements() {
        var activeItems = this.transcript.querySelectorAll(".speech-word.active");

        for (var a = 0; a < activeItems.length; a++) {
          if (activeItems[a]) {
            // TODO: look into why we need this
            activeItems[a].classList.remove("active");
          }
        }
      },
      selectActiveItem: function selectActiveItem() {
        for (var i = 1; i < this.words.length; i++) {
          if (parseFloat(this.words[i].getAttribute("data-start")) > this.player.currentTime) {
            // TODO: look for a better way of doing this
            var strayActive = this.transcript.querySelectorAll(".speech-word.active")[0];

            if (strayActive) {
              strayActive.classList.remove("active");
            } // word time is in the future - set the previous word as active.


            this.words[i - 1].classList.add("active");
            break;
          }
        }
      },
      setPlayerTime: function setPlayerTime(time) {
        if (!isNaN(time)) {
          this.player.currentTime = time;
        }
      },
      setPlayHead: function setPlayHead(e) {
        this.clearActiveElements();
        var target = e.target ? e.target : e.srcElement;
        target.classList.add("active");
        var time = parseFloat(target.getAttribute("data-start"));
        this.setPlayerTime(time);
      },
      checkPlayHead: function checkPlayHead() {
        this.clearActiveElements();
        this.selectActiveItem();
      },
      updateSpeeches: function updateSpeeches(_ref) {
        var speech = _ref.speech,
            updatedSpeech = _ref.updatedSpeech;
        var speaker_id = speech.speaker_id,
            timestamp = speech.timestamp;
        var index = this.speeches.findIndex(function (item) {
          return item.speaker_id === speaker_id && item.timestamp === timestamp;
        });

        var newSpeech = _objectSpread2(_objectSpread2({}, speech), {}, {
          text: updatedSpeech
        });

        var newSpeeches = _objectSpread2(_objectSpread2({}, this.speeches), {}, _defineProperty({}, index, newSpeech));

        this.isDirty = true;
        this.$emit("updateSpeeches", Object.values(newSpeeches));
      },
      selectSpeech: function selectSpeech(speech) {
        this.activeSpeech = _objectSpread2({}, speech);
        this.$emit("changedActiveSpeech", this.isDirty);
        this.isDirty = false;
      }
    }
  };

  /* script */
  const __vue_script__$7 = script$7;
  /* template */
  var __vue_render__$7 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"transcript",staticClass:"textarea scroller has-fixed-size",attrs:{"id":"transcript"}},_vm._l((_vm.speeches),function(speech){return _c('speech',{key:speech.timestamp,attrs:{"speech":speech,"speaker-list":_vm.speakerList,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.emotionHidden,"is-editable":_vm.isEditable},on:{"handleSpeechEdit":_vm.updateSpeeches,"handleSpeechSelect":_vm.selectSpeech}})}),1)};
  var __vue_staticRenderFns__$7 = [];

    /* style */
    const __vue_inject_styles__$7 = undefined;
    /* scoped */
    const __vue_scope_id__$7 = "data-v-bbf13158";
    /* module identifier */
    const __vue_module_identifier__$7 = undefined;
    /* functional template */
    const __vue_is_functional_template__$7 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$7 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
      __vue_inject_styles__$7,
      __vue_script__$7,
      __vue_scope_id__$7,
      __vue_is_functional_template__$7,
      __vue_module_identifier__$7,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  var script$8 = {
    name: "VueTranscriptEditor",
    components: {
      TranscriptHeader: __vue_component__$2,
      Player: __vue_component__$3,
      Transcript: __vue_component__$7
    },
    props: {
      transcript: {
        type: Array,
        required: true
      },
      speakerList: {
        type: Array,
        required: true
      },
      emotionColors: {
        type: Object,
        required: false,
        default: function _default() {
          return emotionColors;
        }
      },
      sourceFile: {
        type: String,
        required: true
      },
      isEditable: {
        type: Boolean,
        default: true
      },
      isEmotionExist: {
        type: Boolean,
        default: false
      },
      headerMargin: {
        type: Number,
        default: 0
      }
    },
    data: function data() {
      return {
        isEmotionHide: true,
        componentWidth: 0
      };
    },
    mounted: function mounted() {
      window.addEventListener("resize", this.updateWidth);
      this.updateWidth();
    },
    methods: {
      updateWidth: function updateWidth() {
        var elementWidth = 0;

        if (this.$refs.editorWrapper) {
          var element = this.$refs.editorWrapper;
          elementWidth = element.clientWidth;
        }

        this.componentWidth = elementWidth;
      },
      updateTranscript: function updateTranscript(speeches) {
        this.$emit("updateTranscript", speeches);
      }
    }
  };

  /* script */
  const __vue_script__$8 = script$8;
  /* template */
  var __vue_render__$8 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"editorWrapper"},[(_vm.isEmotionExist)?_c('transcript-header',{attrs:{"width":_vm.componentWidth,"emotion-colors":_vm.emotionColors,"emotion-hidden":_vm.isEmotionHide,"margin-top":_vm.headerMargin},on:{"emotionToggle":function($event){_vm.isEmotionHide = !_vm.isEmotionHide;}}}):_vm._e(),_vm._v(" "),_c('transcript',{attrs:{"speeches":_vm.transcript,"speaker-list":_vm.speakerList,"emotion-colors":_vm.emotionColors,"emotion-hidden":!_vm.isEmotionExist || _vm.isEmotionHide,"is-editable":_vm.isEditable},on:{"updateSpeeches":_vm.updateTranscript,"changedActiveSpeech":function (isDirty) { return _vm.$emit('changedActiveSpeech', isDirty); }}}),_vm._v(" "),_c('player',{attrs:{"width":_vm.componentWidth,"source-file":_vm.sourceFile}})],1)};
  var __vue_staticRenderFns__$8 = [];

    /* style */
    const __vue_inject_styles__$8 = undefined;
    /* scoped */
    const __vue_scope_id__$8 = undefined;
    /* module identifier */
    const __vue_module_identifier__$8 = undefined;
    /* functional template */
    const __vue_is_functional_template__$8 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    const __vue_component__$8 = /*#__PURE__*/normalizeComponent(
      { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
      __vue_inject_styles__$8,
      __vue_script__$8,
      __vue_scope_id__$8,
      __vue_is_functional_template__$8,
      __vue_module_identifier__$8,
      false,
      undefined,
      undefined,
      undefined
    );

  var version = "0.4.1-next.0"; // Declare install function executed by Vue.use()

  function install(Vue) {
    if (install.installed) return;
    install.installed = true;
    Vue.component("VueTranscriptEditor", __vue_component__$8);
  }
  var VPlugin = {
    install: install,
    version: version,
    VueTranscriptEditor: __vue_component__$8
  }; // Auto-install when vue is found (eg. in browser via <script> tag)

  var GlobalVue = null;

  if (typeof window !== "undefined") {
    GlobalVue = window.Vue;
  } else if (typeof global !== "undefined") {
    GlobalVue = global.Vue;
  }

  if (GlobalVue) {
    GlobalVue.use(VPlugin);
  }
  /*************************************************/

  exports.VueTranscriptEditor = __vue_component__$8;
  exports.default = VPlugin;
  exports.install = install;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
